//
//  Logic.swift
//  POSTS
//
//  Created by admin on 26.02.18.
//  Copyright © 2018 admin. All rights reserved.
//

import UIKit
import MapKit
import Foundation
import Alamofire
import ObjectMapper

class User:Mappable
{
    required init?(map: Map) {
    }
    
    var id:String = ""
    var login:String = ""
    var password:String = ""
    var avatar:UIImage?
    var posts:[Post]?
    

    
    public func mapping(map: Map) {
        self.login <-  map["login"]
        self.password <- map["password"]
        self.id <- map["id"]
    }
}
class Post:Mappable {
    required init?(map: Map) {
    }
    var id:String = ""
    var text:String = ""
    var description:String = ""
    var lat:Double = 0
    var lng:Double = 0
    var photo:String = ""
    var idUser:String = ""
    
    public  func mapping(map: Map) {
        self.text <-  map["title"]
        self.description <- map["description"]
        self.id <- map["idUser"]
        self.photo <- map["photo"]
        self.lat <- map["lat"]
        self.lng <- map["lng"]
        self.idUser <- map["idUser"]
        
    }
    public init(idPost:String,text:String,description:String,lat:Double,lng:Double,photo:String,idUser:String)
    {
        self.id = idPost
        self.description = description
        self.lat = lat
        self.lng = lng
        self.photo = photo
        self.idUser = idUser
    }
}




class Logic {
    static var concretUser:User?=nil
    
        var manager: SessionManager
         init() {
            self.manager = Alamofire.SessionManager.default
        }
        func GetUserDetail(urlString:String)
        {
        self.manager.request(urlString).validate(statusCode: 200..<300).responseJSON { response in
            switch response.result {
            case .success:
                //to get JSON return value
                guard let responseJSON = response.result.value as? Array<[String: Any]> else {
                    print("Error reading response")
                    return
                }
                guard let users:[User] = Mapper<User>().mapArray(JSONArray: responseJSON) else {
                    print("Error mapping response")
                    return
                }
                Logic.concretUser = users[0]
                self.GetUserPosts(urlString: "https://post.new-norm.pro/login.php?action=getPost&userId=" + (Logic.concretUser?.id)!)
            case .failure(_):
                print("error")
            }
        }
    }
    func GetUserPosts(urlString:String)
    {
        self.manager.request(urlString).validate(statusCode: 200..<300).responseJSON { response in
            switch response.result {
            case .success:
                //to get JSON return value
                guard let responseJSON = response.result.value as? Array<[String: Any]> else {
                    print("Error reading response")
                    return
                }
               guard let posts:[Post] = Mapper<Post>().mapArray(JSONArray: responseJSON) else {
                    print("Error mapping response")
                    return
                }
               Logic.concretUser?.posts=posts
            case .failure(_):
                print("error")
            }
        }
    }
}
    
  
   
    


